%eden
/* $Id: eddipf.e,v 1.1 2001/09/27 14:06:05 cssbz Exp $ */
/*
	File:		eddipf.e
	Program: 	EDEN functions for EDDI/P
	Author:		Son V Truong
        Generally messed around with since by Ashley and Meurig
*/

/* Make a version of a table with no repeated rows */
func Makedistinct {
	para l;
	auto result, elt, ix;
	result = [];
	while (l#!=0) {
		elt = l[1];
		shift l;
		ix = 1;
		while ((ix<=result#)&&(elt!=result[ix])) ix++;
		if (result#<ix) result = result // [elt];
	}
	return result;
};

func DummyDistinct {
	para l;
	return l;
}

EDDI_distinct = 1;
makedistinct is ((EDDI_distinct) ? Makedistinct : DummyDistinct);

proc markFunctionsWhenGlobalStateChanges : EDDI_distinct {
  touch(&union, &diff, &inter, &project, &select, &rdupcols);
}

func create
/* table = (c1,k/n,c2,k/n,...,cN,k/n) */
{
	auto i, tlist;
	tlist = [[[]]];
	for (i=1; i<=$#; i+=2)
	{
		append tlist[1],$[i];
		if ($[i+1] == "#")
			append tlist[1][1],1;
		else
			append tlist[1][1],0;
	}
	return tlist;
}

func ucompat
/* bool = ucompat(t1,t2) */
{
	return ($1[1][1] == $2[1][1]);
}

func notin
/* bool = notin(t,v) */
{
	auto i,j;
	for (i=1; i<=$1#; i++)
	{
		if ($1[i] == $2)
			return 0;
	}
	return 1;
}

func showrel
/* showrel(t) */
{
	auto i,j;
	if ($1 != [])
	{
		for (i=2; i<=$1[1]#; i++)
                {
                        write("----------------");
                }
		writeln("");
		for (i=2; i<=$1[1]#-1; i++)
		{
			write($1[1][i]);
			write("\t\t");
		}
		writeln($1[1][i]);
		for (i=2; i<=$1[1]#; i++)
                {
                        write("----------------");
                }
		writeln("");
		for (j=2; j<=$1#; j++)
		{
			for (i=1; i<=$1[1]#-2; i++)
		        {
		                write($1[j][i]);
		                write("\t\t");
       		 	}
		        writeln($1[j][i]);
		}
		for (i=2; i<=$1[1]#; i++)
                {
                        write("----------------");
                }
		writeln("");
	}
	else
		writeln("EDEN: table is empty.");
	
}

func addvals
/* table2 = addvals(t1,tup1,tup2,...,tupN) */
{
	auto i;
        for (i=2; i<=$#; i++)
	{
		if ($1[1]#-1 == $[i]#)
		{
			if (notin($1,$[i])==1)
				append $1,$[i];
			else
				writeln("EDDI/EDEN ERROR: tuple exists already.");
		}
		else
			writeln("EDEN: ERROR: incorrect number of values.");
	}
	return $1;
}

func delvals
/* table2 = delvals(t1,v1,v2,...,vN) */
{
	auto i,j;
	for (i=2; i<=$#; i++)
		if ($1[1]#-1 == $[i]#)
		{
			for (j=2; j<=$1#; j++)
				if ($1[j] == $[i])
					delete $1,j;
		}
		else
		{
			writeln("EDEN: ERROR: incorrect number of values.");
			return $1;
		}
	return $1;
}

func union
/* table3 = union(table1,table2) */
{
	auto i;
	if (ucompat($1,$2) != 1)
	{
		writeln("EDEN: ERROR: tables are not union-compatible.");
		return [[[]]];
	}
	else
	{
		for (i=2; i<=$2#; i++)
			append $1,$2[i];
		return makedistinct($1);
	}

}

func getindex
/* index = getindex(t) */
{
	return $1[1][1];
}

func getkeys
/* keys = getkeys(t) */
{
	auto i,j, index;
	key = [];
	keylist = [];
	index = getindex($1);
	for (j=2; j<=$1#; j++)
	{
		for (i=1; i<=index#; i++)
			if (index[i] == 1)
				append key, $1[j][i];
		append keylist, key;
		key = [];
	}
	return keylist;
}

func diff
/* t3 = diff(t1,t2) */
{
	auto i, j, k;
	tlist = $1;
	dlist = [];	
        if (ucompat($1,$2) != 1)
        {
                writeln("EDEN: ERROR: tables are not union-compatible.");
                return [[[]]];
        }
	else
	{
		for (j=2; j<=$1#; j++)
			for (k=2; k<=$2#; k++)
				if ($1[j] == $2[k])
					append dlist, $1[j];
		for(i=1;i<=dlist#;i++)
			tlist = delvals(tlist,dlist[i]);
		return makedistinct(tlist);
	}
}

func inter
/* t3 = inter(t1,t2) */
{
        auto j, k, tlist;
        tlist = [];
        if (ucompat($1,$2) != 1)
        {
                writeln("EDEN: ERROR: tables are not union-compatible.");
                return [[[]]];
        }
	else
	{
		append tlist, $1[1];
	        for (j=2; j<=$1#; j++)
        	        for (k=2; k<=$2#; k++)
                	        if ($1[j] == $2[k])
                        	        append tlist, $1[j];
	        return makedistinct(tlist);
	}
}

func getcolumn
/* c_number = getcolumn(t,c) */
{
	auto i,j;
	j = 0;
	for (i=2; i<=$1[1]#; i++)
		if ($1[1][i] == $2)
		{
			j = i;
			break;
		}
	if (j != 0)
		return j-1;
	else
	{
		writeln("EDEN: ERROR: column not found.");
		return 0;
	}
}

func project
/* t2 = project(t1,c_list) */
{
	auto i,j,k;
	tlist = [[[]]];
	for (i=1; i<=$2#; i++)
		append tlist[1],$2[i];
        for (i=2; i<=$1#; i++)
                append tlist,[];
	for (i=1; i<=$2#; i++)
	{
		addcol = getcolumn($1,$2[i]);
		append tlist[1][1], $1[1][1][addcol];
		for (j=2; j<=$1#; j++)
			append tlist[j], $1[j][addcol];
	}
	return makedistinct(tlist);
}

func getcolval
{
	auto i,j;
	tlist = [];
	for (i=2; i<=$1#; i++)
		append tlist,$1[i][$2];
	return tlist;
}

func select
/* t2 = select(t1,c,c_op,c_val) */
{
	auto i,j,k,addcol;
	tlist1 = [];
	append tlist1, $1[1];
	keys = getcolval($1,getcolumn($1,$2));
	switch($3)
	{
		case "==" :
		{
			for (i=1; i<=keys#; i++)
			{
				if (keys[i] == $4)
					append tlist1,$1[i+1];
			}
			break;
		}
		case "!=" :
		{
			for (i=1; i<=keys#; i++)
			{
				if (keys[i] != $4)
					append tlist1,$1[i+1];
			}
			break;
		}
		case "<" :
		{
			for (i=1; i<=keys#; i++)
			{
				if (keys[i] < $4)
					append tlist1,$1[i+1];
			}
			break;
		}
		case "<=" :
		{
			for (i=1; i<=keys#; i++)
			{
				if (keys[i] <= $4)
					append tlist1,$1[i+1];
			}
			break;
		}
		case ">" :
		{
			for (i=1; i<=keys#; i++)
			{
				if (keys[i] > $4)
					append tlist1,$1[i+1];
			}
			break;
		}
		case ">=" :
		{
			for (i=1; i<=keys#; i++)
			{
				if (keys[i] >= $4)
					append tlist1,$1[i+1];
			}
			break;
		}
		default : writeln("EDDI/P Error: not a comparison.");
	}
	return makedistinct(tlist1);
}

func getkcols
{
	auto i;
	tlist = [];
	for (i=1; i<=$1[1][1]#; i++)
		if ($1[1][1][i] == 1)
			append tlist, $1[1][i+1];
	return tlist;
}

func rdupcols
{
	auto i,j,k;
	tlist = [[[]]];
	colnos = [2];
	delcols = [$1[1][2]];
	for (i=3; i<=$1[1]#; i++)
		if (notin(delcols,$1[1][i]))
		{
			append colnos, i;
			append delcols, $1[1][i];
		}
	for (j=1; j<=colnos#; j++)
	{
		append tlist[1][1], $1[1][1][colnos[j]-1];
		append tlist[1], $1[1][colnos[j]];
	}
	for (k=2; k<=$1#; k++)
	{
		append tlist, [];
		for (j=1; j<=colnos#; j++)
			append tlist[k], $1[k][colnos[j]-1];
	}
	return makedistinct(tlist);
}

func matchcols
/* [[mct1],[mct2]] = matchcols(t1,t2) */
{
	auto i,j;
	mct1 = [];
	mct2 = [];
	for(i=2;i<=$1[1]#;i++)
		for(j=2;j<=$2[1]#;j++)
		{
			if ($1[1][i] == $2[1][j])
			{
				append mct1,i;
				append mct2,j;
			}
		}
	return [mct1,mct2];
}

func njoin
{
        auto i,j,k,x,y,z;
        tlist1 = [];
	vals1 = [];
	vals2 = [];
	nvals1 = [];
	nvals2 = [];
        append tlist1, $1[1];
	matcols = matchcols($1,$2);
	if (matcols != [[],[]])
	{
		for (i=1; i<=matcols[1]#; i++)
			append vals1, getcolval($1,matcols[1][i]-1);
		for (i=1; i<=matcols[2]#; i++)
			append vals2, getcolval($2,matcols[2][i]-1);
		for (j=1; j<=vals1[1]#; j++)
		{	
			append nvals1, [];
			for (k=1; k<=vals1#; k++)
				append nvals1[j], vals1[k][j];
		}
        	for (j=1; j<=vals2[1]#; j++)
	        {
	                append nvals2, [];
        	        for (k=1; k<=vals2#; k++)
	                        append nvals2[j], vals2[k][j];
		}
		attr = $1[1];
		attr[1] = attr[1] // $2[1][1];
		for (i=2; i<=$2[1]#; i++)
			append attr, $2[1][i];
		tlist = [attr];
		z = 1;
		for (x=1; x<=nvals1#; x++)
			for (y=1; y<=nvals2#; y++)
				if (nvals1[x] == nvals2[y])
				{
					append tlist, $1[x+1];
					z++;
					for (i=1; i<=$2[y+1]#; i++)
						append tlist[z], $2[y+1][i];
				}
		return rdupcols(tlist);
	}
	else
	{
		attr = $1[1];
		attr[1] = attr[1] // $2[1][1];
		for (i=2; i<=$2[1]#; i++)
                        append attr, $2[1][i];
                tlist = [attr];
		for (x=2;x<=$1#;x++)
			for (y=2; y<=$2#; y++)
			{
				append tlist, ($1[x] // $2[y]);
			}
		return tlist;
	}
}

func epipe
{
	auto i;
	tlist = [];
	for(i=2;i<=$1#;i++)
		append tlist,$1[i];
	return tlist;
}
